@ECHO OFF

REM    **********   SHUTDOWN (+ Export:sys&user.reg) Batch File   ***********

REM 1. Remove Windows "Recent" File Shortcuts (in WINDOWS\Recent folder)
REM 2. Remove misc. useless Windows Registry entries:
REM  a. Save Desktop Stream in ~temp1.reg & ~temp2.reg
REM  b. Run "KillCrap.reg" (in WINDOWS folder),
REM     Wait for RegEdit to finish importing -- Pause 3 Seconds (presumably enough time)
REM  c. Restore Desktop Stream
REM  d. Restore Explorer View Stream Settings
REM     (using the Registry file "ExplorerViewStream.reg", in WINDOWS folder)
REM 3. Run RegEdit to export Registry as a File:  C:\windows\sys&user.reg.
REM 4. Save Backup, Empty "Cookies" folder (if it exists) in Temporary folder "C:\WINDOWS\COOKIES0\"
REM      (This MUST be copied while WINDOWS is running - long File names)
REM 5. Pause until RegEdit has finished (& File is moved from "TEMP\" to "C:\"):
REM  a. Open "'About Window' Window" (de-Focus from this window - does a faster export)
REM /_. Run Screen Saver "TEMP\ScrnSave.exe"  ('SSSTARS.SCR' - if present):
REM /    (Verify existence of file "ScrnSave.exe" in TEMP Directory
REM /     - If not present:  Copy "WINDOWS\SYSTEM\SSSTARS.SCR" to "TEMP\ScrnSave.exe")
REM /_. Run Screen Saver "WINDOWS\SpongeBobScreensaver.scr"
REM  c. Pause for 10 Seconds at a time... - until RegEdit is finished exporting.
REM 6. Shutdown Windows:  Run "RUNDLL.EXE SHELL32.DLL,SHExitWindowsEx".

REM ( N.B.: To Include "sys&user.reg" in the Windows System File Backup Cabinet:
REM         ADD the line:
REM                       Files=10,sys&user.reg
REM         to the end of the file "SCANREG.INI" in the "WINDOWS" directory.       )

REM   Philip C. Dybel     7 SEP, 15 OCT, 10 NOV 2005;  8 JUL 2006;  2007;  1 FEB 2008


REM 1. Remove Windows "Recent" File Shortcuts:
ECHO Removing Windows "Recent" File Shortcuts...
echo Y | del %windir%\recent\*.*


REM 2. Remove misc. useless Windows Registry entries:
ECHO.
ECHO Removing misc. useless Windows Registry entries...

REM Ensure existence of "TEMP" Directory (via "SET"):
IF %TEMP%x == %nul%x SET TEMP=C:\TEMP
IF NOT EXIST %TEMP%\nul MD %TEMP%

rem 2a. Save Desktop Stream(s) in ~temp*.reg (in TEMP folder):
ECHO  Saving Desktop Stream(s)...
%windir%\REGEDIT.EXE /E %TEMP%\~temp1.reg "HKEY_USERS\.DEFAULT\Software\Microsoft\Windows\CurrentVersion\Explorer\Streams\Desktop"
%windir%\REGEDIT.EXE /E %TEMP%\~temp2.reg "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Streams\Desktop"

rem 2b. Run "KillCrap.reg":
ECHO.
ECHO  Running "KillCrap.reg"...
@ECHO ON
%windir%\REGEDIT.EXE /S %windir%\KillCrap.reg
@ECHO OFF

ECHO.
ECHO Waiting (for RegEdit to finish importing) 'KillCrap.reg'...
ECHO.
CHOICE /C:. /T:.,3 /N "Pausing for 3 seconds.."

rem 2c. Restore Desktop Stream(s):
ECHO  Restoring Desktop Stream(s)...
%windir%\REGEDIT.EXE /S %TEMP%\~temp1.reg
%windir%\REGEDIT.EXE /S %TEMP%\~temp2.reg

rem 2d. Restore Explorer View Stream Settings:
%windir%\REGEDIT.EXE /S %windir%\ExplorerViewStream.reg


REM 3. Run RegEdit to export Registry as File "%windir%\sys&user.reg":
ECHO.
ECHO Running "RegEdit" to export Registry as File:  "sys&user.reg":

@ECHO ON
DEL %windir%\sys&user.reg
DEL %TEMP%\sys&user.reg
%windir%\REGEDIT.EXE /E %TEMP%\sys&user.reg
@ECHO OFF


REM 4. Save Backup, Empty "Cookies" folder (if it exists as "C:\WINDOWS\SYSBCKUP\Cookies\")
ECHO.
ECHO Copy: Backup, Empty "Cookies" folder (if "C:\WINDOWS\SYSBCKUP\Cookies\" exists):
IF NOT EXIST %windir%\SYSBCKUP\Cookies\NUL GOTO NoCopy

:Copy
IF EXIST %windir%\COOKIES0\NUL %windir%\command\DELTREE /Y %windir%\COOKIES0
ECHO ..Copying to Temporary folder "%windir%\COOKIES0\"
@ECHO ON
XCOPY C:\WINDOWS\SYSBCKUP\Cookies %windir%\COOKIES0\
@ECHO OFF
ATTRIB -A %windir%\COOKIES0\*.*
GOTO NextStep

:NoCopy
ECHO ..[Emptied WINDOWS "Cookies" folder NOT found as "C:\WINDOWS\SYSBCKUP\Cookies\"]

:NextStep


REM 5. Pause until RegEdit has finished:

ECHO.
ECHO Waiting for RegEdit to finish export as "sys&user.reg"...


REM  5a. Open 'About Window Window' (to de-Focus from this window's 'CHOICE' below):
rundll32 shell32,ShellAboutA Info-Box


rem REM 5_. Run Screen Saver 'SSSTARS.SCR':

rem REM Ensure existence of "TEMP\ScrnSave.exe" Screen-Saver file  (Copy 'SSSTARS' if necc.):
rem IF NOT EXIST %TEMP%\ScrnSave.exe COPY %windir%\SYSTEM\SSSTARS.SCR %TEMP%\ScrnSave.exe

rem REM Run it:
rem %TEMP%\ScrnSave.exe /S


rem REM 5_. Run Screen Saver 'SpongeBobScreensaver.scr':

rem @ECHO ON
rem WINDOWS\SpongeBobScreensaver.exe
rem @ECHO OFF


REM 5b. Loop - Pause for 10 Seconds at a time (until finished):
:Wait
ECHO.
CHOICE /C:. /T:.,10 /N "Pausing for 10 seconds.."

REM Check for Finish - Try to 'Move' File  (Un-Finished file Will Not 'Move'):
MOVE %TEMP%\sys&user.reg %windir%\sys&user.reg

IF NOT EXIST %windir%\sys&user.reg GOTO Wait

REM "sys&user.reg" Finished -- Set file Attributes to NOT "Archive":
ATTRIB -A %windir%\sys&user.reg


rem Delete temp files - from "2c. Restore Desktop Stream":
DEL %TEMP%\~temp1.reg
DEL %TEMP%\~temp2.reg


REM 6. Shutdown Windows:
@ECHO ON
%windir%\RunDll.exe Shell32.dll,SHExitWindowsEx 1
